----------------------------------------------------------------------------------
--                   DPSMeter by Sentri(Daedal) at Darksorrow EU                --
-- The code is not very clean, and some things are done in a complicated way,   --
-- I know, but I'm no longer updating this in a while, only to maintain its     --
-- compability on new patches. (I think) Maybe later I'll clean this up and     --
-- continue the development. (Omg some stuff in this code is WEIRD, lol)        --
----------------------------------------------------------------------------------

DPSMeter = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0");
dewdrop = AceLibrary("Dewdrop-2.0");

local DPSSESSIONSECS, DPSSESSIONDMG, DPSSESSIONBEST, DPSSESSIONTOPHIT, DPSSESSIONAVG, DPSMETERDEBUG = 0,0,0,0,0,false;
local DPSSESSIONSPELL = "none";
local DPSDMGMETERS = { ["damage"] = {},["healing"] = {}};
local DPSMETERNAMES = {};
local DPSDMGMETERINFO = {["isRaid"] = false, ["isParty"] = false, ["members"] = 0};
local DPSDMGTOTALS = {["healing"] = 0, ["damage"] = 0};
local DPSM_DAMAGE, DPSM_TIME, DPSM_COMBAT, DPSM_MAXDPS, DPSM_MAXCHART, DPSTEMP1, DPSSHOWING, DPSMETERBARS = 0, 0, false, 40, 40, 0, "damage", 0;
local DPSMETERVERSION = 1.51;
local lastcombattime, DPSTIMERON = GetTime(), false;

StaticPopupDialogs["DPSMETERBETA"] = {
  text = "Are you sure you want to enable damage meters?\nThey are (still) only in beta testing and it might cause errors and/or incorrect values.",
  button1 = "Yes",
  button2 = "No",
  OnAccept = function()
      DPSMenu_RecEn();
  end,
  timeout = 0,
  whileDead = 1,
  hideOnEscape = 1
};

--################ TINY MENU FUNCS ###################
function DPSMenu_reset()
DPSM_MAXCHART = 40; DPSM_DAMAGE = 0; DPSM_TIME = 0; DPSM_COMBAT = false; DPSM_MAXDPS = 40;
DPSMETERDEBUG = false;
DPSSESSIONSECS, DPSSESSIONDMG, DPSSESSIONBEST, DPSSESSIONTOPHIT, DPSSESSIONAVG = 0,0,0,0,0;
DPSSESSIONSPELL = "none";
end
function DPSMenu_Lock()
DPSMeter.db.char.lock = true;
DPSMeterFrame.isLocked = true;
DPSMeterDamage.isLocked = true;
DPSDamageResize:Hide();
dewdrop:Close();
end
function DPSMenu_UnLock()
DPSMeter.db.char.lock = false;
DPSMeterFrame.isLocked = false;
DPSMeterDamage.isLocked = false;
DPSDamageResize:Show();
dewdrop:Close();
end
function DPSMenu_ScEn()
DPSMeter.db.char.scen = true;
dewdrop:Close();
end
function DPSMenu_ScDis()
DPSMeter.db.char.scen = false;
dewdrop:Close();
end
function DPSMenu_HealEn()
DPSMeter.db.char.heal = true;
dewdrop:Close();
end
function DPSMenu_HealDis()
DPSMeter.db.char.heal = false;
dewdrop:Close();
end
function DPSMenu_RecDis()
DPSMeter.db.char.record = false;
dewdrop:Close();
DPSMeterDamage:Hide();
DPSMeter:Print("Damage meters disabled.");
end
function DPSMenu_RecEn()
DPSMeter.db.char.record = true;
dewdrop:Close();
DPSMeterDamage:Show();
DPSMeter:Print("Damage meters enabled.");
end
function DPSMenu_RecRes()
if (DPSMeter.db.char.record == true) then
dewdrop:Close();
DPSDMGMETERS = {};
DPSDMGMETERS["damage"] = {};
DPSDMGMETERS["healing"] = {};
DPSMeter:Print("Damage meters reseted.");
else
DPSMeter:Print("The damage recording is not enabled. You can enable it from the menu.");
end
end
function DPSMeterNot(value)
if (value == true) then return false; else return true; end
-- wtf? why did I do this func? lol it's hard to understand old code, even if it's my own. oh well...
end
--####################################################
function DPSMeter_Menu()
	dewdrop:Open(DPSMeterFrame,
    'children', 
    function()
		dewdrop:AddLine('text', "Enable dmg/heal meters", 'checked', DPSMeter.db.char.record, 'func', DPSMenu_RecEn, 'tooltipTitle', "Enable recording",	'tooltipText', "Enable recording damage and healing of party")
        dewdrop:AddLine('text', "Disable dmg/heal meters", 'checked', DPSMeterNot(DPSMeter.db.char.record), 'func', DPSMenu_RecDis, 'tooltipTitle', "Disable recording",	'tooltipText', "Disable recording damage and healing of party")
        dewdrop:AddLine('text', "Print dmg meters", 'func', DPSMeter_PrintRec, 'arg1', "damage", 'tooltipTitle', "Print DMG Meters",	'tooltipText', "Print all damage meter records to chat frame")
        dewdrop:AddLine('text', "Print heal meters", 'func', DPSMeter_PrintRec, 'arg1', "healing", 'tooltipTitle', "Print Heal Meters",	'tooltipText', "Print all healing records to chat frame")
        dewdrop:AddLine('text', "Broadcast dmg meters", 'func', DPSMeter_PrintRec, 'arg1', "damage", 'arg2', 'SAY', 'tooltipTitle', "Broadcast DMG Meters",	'tooltipText', "Broadcast all damage meter records to party/raid chat")
        dewdrop:AddLine('text', "Broadcast heal meters", 'func', DPSMeter_PrintRec, 'arg1', "healing", 'arg2', 'SAY', 'tooltipTitle', "Broadcast Heal Meters",	'tooltipText', "Broadcast all healing records to party/raid chat")
        dewdrop:AddLine('text', "Reset DMG & Heal meters", 'func', DPSMenu_RecRes, 'tooltipTitle', "Reset DMG meters",	'tooltipText', "Reset all damage meter records")
        dewdrop:AddSeparator()
        dewdrop:AddLine(
    		'text', "Set scale",
    		'tooltipTitle', "Scale",
    		'tooltipText', "Sets the scale of the whole frame",
    		'hasArrow', true,
    		'hasSlider', true,
    		'sliderMin', 0.5,
    		'sliderMax', 1.5,
    		'sliderStep', 0.1,
    		'sliderValue', DPSMeter.db.char.scale,
    		'sliderMinText', '50%',
    		'sliderMaxText', '150%',
    		'sliderFunc', function(value)	DPSMeter.db.char.scale = value; DPSMeterFrame:SetScale(value); end
			)
        dewdrop:AddLine(
    		'text', "Set normal transparency",
    		'tooltipTitle', "Normal Transparency",
    		'tooltipText', "Sets the normal transparency of the whole frame",
    		'hasArrow', true,
    		'hasSlider', true,
    		'sliderMin', 0.1,
    		'sliderMax', 1.0,
    		'sliderStep', 0.1,
    		'sliderValue', DPSMeter.db.char.alpha,
    		'sliderMinText', '10%',
    		'sliderMaxText', '100%',
    		'sliderFunc', function(value)	DPSMeter.db.char.alpha = value; DPSMeterFrame:SetAlpha(value); end
			)
		dewdrop:AddLine(
    		'text', "Set combat transparency",
    		'tooltipTitle', "Combat Transparency",
    		'tooltipText', "Sets the transparency of the whole frame while in combat",
    		'hasArrow', true,
    		'hasSlider', true,
    		'sliderMin', 0.1,
    		'sliderMax', 1.0,
    		'sliderStep', 0.1,
    		'sliderValue', DPSMeter.db.char.alpha2,
    		'sliderMinText', '10%',
    		'sliderMaxText', '100%',
    		'sliderFunc', function(value)	DPSMeter.db.char.alpha2 = value; end
			)
		dewdrop:AddSeparator()
        dewdrop:AddLine('text', "Lock Frames", 'func', DPSMenu_Lock, 'tooltipTitle', "Lock", 'checked', DPSMeter.db.char.lock,	'tooltipText', "Locks the frame in place so it can't be dragged")
        dewdrop:AddLine('text', "Unlock Frames", 'func', DPSMenu_UnLock, 'tooltipTitle', "Unlock", 'checked', DPSMeterNot(DPSMeter.db.char.lock),	'tooltipText', "Unlocks the frame so it can be dragged")
        dewdrop:AddSeparator()
		dewdrop:AddLine('text', "Skin: Normal", 'func', DPSMeter_NormalSkin, 'tooltipTitle', "Skin: Normal", 'checked', DPSMeter.db.char.skin,	'tooltipText', "The default skin of the AddOn")
        dewdrop:AddLine('text', "Skin: Digital", 'func', DPSMeter_DigitSkin, 'tooltipTitle', "Skin: Digital", 'checked', (not DPSMeter.db.char.skin),	'tooltipText', "A secondary skin which only shows the digital DPS number")
        dewdrop:AddSeparator()
        dewdrop:AddLine('text', "Reset DPSMeter", 'func', DPSMenu_reset, 'tooltipTitle', "Reset",	'tooltipText', "Resets the meter, if you have any errors")
        dewdrop:AddSeparator()
        dewdrop:AddLine('text', "Enable SCT display", 'func', DPSMenu_ScEn, 'tooltipTitle', "Enable SCT", 'checked', DPSMeter.db.char.scen,	'tooltipText', "Enable displaying DPS in SCT addon")
        dewdrop:AddLine('text', "Disable SCT display", 'func', DPSMenu_ScDis, 'tooltipTitle', "Disable SCT", 'checked', DPSMeterNot(DPSMeter.db.char.scen),	'tooltipText', "Disable displaying DPS in SCT addon")
        dewdrop:AddSeparator()
        dewdrop:AddLine('text', "Enable heals", 'func', DPSMenu_HealEn, 'tooltipTitle', "Enable heals", 'checked', DPSMeter.db.char.heal,	'tooltipText', "Enable counting of healing spells during combat")
        dewdrop:AddLine('text', "Disable heals", 'func', DPSMenu_HealDis, 'tooltipTitle', "Disable heals", 'checked', DPSMeterNot(DPSMeter.db.char.heal),	'tooltipText', "Disable counting of healing spells during combat")
        dewdrop:AddSeparator()
        dewdrop:AddLine('text', "Close", 'closeWhenClicked', true, 'tooltipTitle', "Close",	'tooltipText', "Close this menu")
    end)
end

function DPSMeter_AddMes(message, color)
	if (DPSMeter.db.char.scen == false) then return end;
	if (not SCT) then return end;
	if (color == nil) then color = {r=1,g=1,b=1}; end
	if (DPSMeter.db.char.frame == "1") then
		SCT:DisplayText(message, color, nil, "event", SCT.FRAME1);
	end
	if (DPSMeter.db.char.frame == "2") then
		SCT:DisplayText(message, color, nil, "event", SCT.FRAME2);
	end
end

function DPSMeter_DigitSkin()
	DPSMeter.db.char.skin = false;
	Speedoback:Hide();
	Speedostick:Hide();
	for i=1, 7 do
		getglobal("DPSmarker"..i):Hide();
	end
	DPSDigital:SetFont("Interface\\AddOns\\DPSMeter\\Fonts\\DIGI.TTF", 30);
	DPSDigital:ClearAllPoints();
	DPSDigital:SetPoint("CENTER", DPSMeterFrame,"CENTER",0,0);
	DPSMeterFrame:SetWidth(50);
	DPSMeterFrame:SetHeight(50);
end

function DPSMeter_NormalSkin()
    DPSMeter.db.char.skin = true;
	Speedoback:Show();
	Speedostick:Show();
	for i=1, 7 do
		getglobal("DPSmarker"..i):Show();
	end
	DPSDigital:SetFont("Interface\\AddOns\\DPSMeter\\Fonts\\DIGI.TTF", 14);
	DPSDigital:ClearAllPoints();
	DPSDigital:SetPoint("CENTER", DPSMeterFrame,"CENTER",0,-37);
	DPSMeterFrame:SetWidth(150);
	DPSMeterFrame:SetHeight(150);
end


function DPSMeter_gg()
	--old, does nothing anymore
end

function DPSMeter_updateparty()
	--store guids in a table (maybe a slow method but it works)
	--check if raid or party
	--DPSMenu_RecRes();
	DPSMETERNAMES = {};
	local isRaid, isParty, members;
	local raid = GetNumRaidMembers();
	if (raid == 0) then isRaid = false; else isRaid = true; end
	if (isRaid == false) then
	members = GetNumPartyMembers(); --parteeeiiiii
	if (members == 0) then isParty = false; else isParty = true; end
	else
	members = raid; -- raid
	end
	--store for other uses
	DPSDMGMETERINFO["isRaid"] = isRaid;
	DPSDMGMETERINFO["isParty"] = isParty;
	DPSDMGMETERINFO["members"] = members;
	-- ok now we have the info about party or raid. so now check the GUIDs out
	DPSMETERNAMES[UnitGUID("player")] = UnitName("player");
	if (isRaid == true) then
	--raid
		DPSMeter_SetBars(members);
		for i=1, members, 1 do
			local uid = "raid"..i;
			local uname, uguid = UnitName(uid), UnitGUID(uid);
			DPSMETERNAMES[uguid] = uname;
		end
	else
	--party
		if (isParty == true) then
			DPSMeter_SetBars(members+1);
			for i=1, members, 1 do
				local uid = "party"..i;
				local uname, uguid = UnitName(uid), UnitGUID(uid);
				DPSMETERNAMES[uguid] = uname;
			end
		end
	end
	--woot now we have teh names
end

function DPSMeter_findkey(array, value)
local a;
  for key,val in pairs(array) do
    if (val == value) then a= key; end
  end
return a;
end

function DPSMeter_PrintLines(names, orig, sorti, what, where)
	table.sort(sorti, function(a,b) return a>b end)
	for i,n in pairs(sorti) do
		local t = DPSMeter_findkey(orig,n);
		local w = names[t];
		DPSMeter_swpr(i..". "..w..": "..n.." "..what, where);
		orig[t] = nil;
	end
end

function DPSMeter_swpr(what,where)
	if (where ~=nil) then 
		if (DPSDMGMETERINFO["isRaid"] == true) then
			SendChatMessage(what,"RAID");
		else
			SendChatMessage(what,"PARTY");
		end
	else
	DEFAULT_CHAT_FRAME:AddMessage(what);
	end
end

function DPSMeter_PrintRec(what, where)
	if (DPSMeter.db.char.record == true) then
		--TEMPORARY PRINTING
		local sorta = {};
		local data = {};
		local orig = {};
		DPSMeter_swpr("-----DPSMeter v"..DPSMETERVERSION.." "..what.." records-----", where);
		local name = UnitName("player");
		local dmg = DPSDMGMETERS[what][name];
		if (dmg == nil) then dmg = 0; end
		if (DPSDMGMETERINFO["isRaid"] == false) then 
			--DPSMeter_swpr(name..": "..dmg.." "..what, where); OLD
			local x = DPSDMGMETERINFO["members"];
			data[x+1] = name;
			sorta[x+1] = dmg;
			orig[x+1] = dmg;
		end
		--now start others
		if (DPSDMGMETERINFO["isRaid"] == true) then
		--woo raid
			for i=1, DPSDMGMETERINFO["members"], 1 do
				local uid = "raid"..i;
				local name = UnitName(uid);
				local dmg = DPSDMGMETERS[what][name];
				if (dmg == nil) then dmg = 0; end
				--DPSMeter_swpr(name..": "..dmg.." "..what, where); OLD
				data[i] = name;
				sorta[i] = dmg;
				orig[i] = dmg;
			end 
		else if (DPSDMGMETERINFO["isParty"] == true) then
		--woo party
			for i=1, DPSDMGMETERINFO["members"], 1 do
				local uid = "party"..i;
				local name = UnitName(uid);
				local dmg = DPSDMGMETERS[what][name];
				if (dmg == nil) then dmg = 0; end
				--DPSMeter_swpr(name..": "..dmg.." "..what, where); OLD
				data[i] = name;
				sorta[i] = dmg;
				orig[i] = dmg;
			end 
		end	
		end
		--arrays sorted, now flush...
		--local sorted = DPSMeter_flush(tempdata, sortarray);
		--and, print: TEST TEST
		DPSMeter_PrintLines(data, orig, sorta, what, where);
		--DEFAULT_CHAT_FRAME:AddMessage("---------------------------------------");	
	else
	DPSMeter:Print("The damage recording is not enabled. You can enable it from the menu.");
	end
end

function DPSMeter_Record(sourceGUID,amount,healz)
	local name;
	if (not DPSMETERNAMES[sourceGUID]) then return end; --not in our party
	name = DPSMETERNAMES[sourceGUID];
	if (healz) then
		--record healing
		if (DPSDMGMETERS["healing"][name] == nil) then DPSDMGMETERS["healing"][name] = 0; end --if first heal
		DPSDMGTOTALS["healing"] = DPSDMGTOTALS["healing"]+amount;
		DPSDMGMETERS["healing"][name] = DPSDMGMETERS["healing"][name]+amount;
	else
		--record dmg
		if (DPSDMGMETERS["damage"][name] == nil) then DPSDMGMETERS["damage"][name] = 0; end --if first dmg
		DPSDMGTOTALS["damage"] = DPSDMGTOTALS["damage"]+amount;
		DPSDMGMETERS["damage"][name] = DPSDMGMETERS["damage"][name]+amount;
	end
end

local trackedCombatEvents = {
	["SWING_DAMAGE"] = true,
	["RANGE_DAMAGE"] = true,
	["SPELL_DAMAGE"] = true,
	["SPELL_HEAL"] = true,
	["SPELL_PERIODIC_DAMAGE"] = true,
	["SPELL_PERIODIC_HEAL"] = true,
	-- add combat events to listen/watch
	}

function DPSMeter:PLAYER_DEAD()
	DPSMeter:PLAYER_REGEN_ENABLED(); -- end combat
end	

function DPSMeter_parse(timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	local yep = false;
	if (not trackedCombatEvents[event]) then return end
	-- wow we have an event
	ismine = CombatLog_Object_IsA(sourceFlags, COMBATLOG_FILTER_MINE);
	ismypet = CombatLog_Object_IsA(sourceFlags, COMBATLOG_FILTER_MY_PET);
	--if( not ismine and not ismypet )then return end MOVED, FOR RECORDING
	-- wow the event is mine or my pet's
	local spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing, healz, overhealing, textMode, spellId, overkill;
	if (event == "SWING_DAMAGE") then
		healz = false;
		amount, school, resisted, blocked, absorbed, critical, glancing, crushing = select(1, ...);
	else
		if ((event == "SPELL_HEAL") or (event == "SPELL_PERIODIC_HEAL")) then
		healz = true;
		spellId, spellName, spellSchool, amount, overhealing, critical = select(1, ...);
		amount = amount-overhealing;
		else
		healz = false;
		spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing = select(1, ...);
		amount = amount-overkill;
		end
	end
	if (DPSMeter.db.char.record == true) then
	DPSMeter_Record(sourceGUID,amount,healz);
	end
	if ( not ismine and not ismypet ) then return end -- do not count if not mine
	if ( (healz == true) and (DPSM_COMBAT == false) ) then return end; --dont count non combat heals!
	if ( (healz == true) and (DPSMeter.db.char.heal == false) ) then return end; --dont count heals if disabled!
	-- check if records
	local spN;
	if (spellName == nil) then spN = "unknown"; else spN = spellName; end
	DPSMeter_Debugg("add: "..spN.." for "..amount..", ev: "..event);
	if (amount > DPSSESSIONTOPHIT) then
	DPSSESSIONTOPHIT = amount;
	if (spellName ~= nil) then
	DPSSESSIONSPELL = spellName;
	else
	DPSSESSIONSPELL = "Normal hit";
	end
	end
	-- EXIT IF PLAYER IS DEAD!!!!
	if ( UnitIsDeadOrGhost("player") ) then 
		if (DPSM_COMBAT == true) then 
		DPSMeter:PLAYER_REGEN_ENABLED(); --end combat! WE ARE DEAD!
		end
	return --dead or ghost, exit
	end 
	-- well now add the parser thingy
	if (DPSM_COMBAT == false) then 
	DPSMeter:PLAYER_REGEN_DISABLED();
	end
	lastcombattime = GetTime();
	DPSM_DAMAGE = DPSM_DAMAGE+amount;
	DPSMeter_Debugg("HIT: "..amount);
	--DPSMeter_gg();
	-- end!
end

function DPSMeter:PLAYER_REGEN_DISABLED()
	if (DPSM_COMBAT == false) then
	-- combat started!!!!
	DPSDigital:SetText("0");
	DPSM_TIME = GetTime()-0.1;
	DPSTEMP1 = GetTime();
	DPSM_DAMAGE = 0; -- just in case
	DPSM_COMBAT = true;
	end
end

function DPSMeter_round(number)
	if ((number-math.floor(number)) < 0.5) then
	 return math.floor(number);
	else
	 return math.ceil(number);
	end
end

function DPSMeter_CheckTimer() 
	if (DPSTIMERON) then
		DPSMeter:PLAYER_REGEN_ENABLED();
	end
end

function DPSMeter:PLAYER_REGEN_ENABLED()
	local now = GetTime();
	if ((now-lastcombattime)>0.99) then
		DPSTIMERON = false;
		DPSMeter_Debugg("regen enabled, combat end");	
		--combat end! start counting!
		local now = GetTime();
		local diff = (now-DPSM_TIME);
		local dpswas = (DPSM_DAMAGE/diff);
		local rounded = DPSMeter_round(dpswas);
		DPSSESSIONDMG = DPSSESSIONDMG+DPSM_DAMAGE;
		DPSMeter.db.char.damage = DPSMeter.db.char.damage+DPSM_DAMAGE;
		DPSSESSIONSECS = DPSSESSIONSECS+diff;
		DPSSESSIONAVG = DPSSESSIONDMG/DPSSESSIONSECS;
		--done, easy! now add to sct...
		if (rounded > 0) then  --check if DPS: 0
		local vari = {r=0.5,g=0.5,b=1};
		DPSMeter_AddMes("DPS: "..rounded, vari);
		--ChatFrame2:AddMessage("|cff"..DPSMeter.db.char.color.."Damage per second: "..rounded.."|r");
		end
		--now reset
		DPSRotateTexture(Speedostick, 0);
		DPSM_COMBAT = false;
		DPSM_DAMAGE = 0;
	else 
		DPSTIMERON = true;
	end
end

function DPSMeter_GetCmd(msg)
 	if msg then
 		local a,b,c=strfind(msg, "(%S+)"); --contiguous string of non-space characters
 		if a then
 			return c, strsub(msg, b+2);
 		else	
 			return "";
 		end
 	end
end
function DPSMeter_GetArgument(msg)
 	if msg then
 		local a,b=strfind(msg, "=");
 		if a then
 			return strsub(msg,1,a-1), strsub(msg, b+1);
 		else	
 			return "";
 		end
 	end
end

function DPSMeter_Debugg(msg)
	if (DPSMETERDEBUG == true) then
		DPSMeter:Print(msg);
	end
end

function ShowDPSStats()
	--show stat tooltip
	local high, avg, top, spell, dmg, total = DPSSESSIONBEST, DPSSESSIONAVG, DPSSESSIONTOPHIT, DPSSESSIONSPELL, DPSSESSIONDMG, DPSMeter.db.char.damage;
	local ish;
	if (DPSMeter.db.char.heal == false) then
	ish = "";
	else
	ish = "/healing";
	end
	GameTooltip:SetOwner(DPSMeterFrame, "ANCHOR_RIGHT");
	GameTooltip:AddLine("DPSMeter v"..DPSMETERVERSION, 1,1,1);
	GameTooltip:AddLine("by Sentri at Darksorrow EU", 0.5,0.3,1);
	GameTooltip:AddLine("--- Session Stats ---",1,1,1); 
	GameTooltip:AddLine("(updated after combat)",0.5,0.7,1);
	GameTooltip:AddDoubleLine("Highest DPS:", high,  0.5,0.7,1,  1,1,1);
	GameTooltip:AddDoubleLine("Average DPS:", DPSMeter_round(avg),  0.5,0.7,1,  1,1,1);
	GameTooltip:AddDoubleLine("Total damage"..ish..":", dmg,  0.5,0.7,1,  1,1,1);
	GameTooltip:AddDoubleLine("Top Hit:", top,  0.5,0.7,1,  1,1,1);
	GameTooltip:AddDoubleLine("  with spell:", spell,0.5,0.7,1,1,1,1); 
	GameTooltip:AddLine("--- Lifetime Stats ---",1,1,1);
	GameTooltip:AddDoubleLine("Total Damage"..ish..":", total,  0.5,0.7,1,  1,1,1);
	GameTooltip:AddLine("Right-click for options", 1,0.9,0); 
	GameTooltip:Show();
end

function DPSMeter_ParseC(msg)
	local Cmd, SubCmd = DPSMeter_GetCmd(msg); --call to above function
	--showcommands
	if (Cmd == "") then
	DPSMeter:Print("Usage: /dps {reset | about}");
	DPSMeter:Print(" - reset: Reset the addon, if something has gone wrong");
	DPSMeter:Print(" - about: Show information about the addon");
	end
	if (Cmd == "about") then
		DPSMeter:Print("DPS Meter v"..DPSMETERVERSION.." by Sentri (Daedal) at Darksorrow EU realm.");
		DPSMeter:Print("Please report bugs and comment to the addon webpage.");
	end
	if (Cmd == "reset") then
		--should reset almost anything
		DPSMeter:PLAYER_REGEN_DISABLED();
		DPSMeterFrame:ClearAllPoints();
		DPSMeterFrame:SetPoint("CENTER", "UIParent", "CENTER", 0, 0);
		DPSMeter.db.char.color = "FF00FF";
   		DPSMeter.db.char.frame = "1";
   		DPSMenu_reset();
		DPSMenu_RecRes();
		DPSMeter:Print("DPS Meter reseted.");
	end
	if (Cmd == "debug") then
		--debugges
		if (DPSMETERDEBUG == true) then
		DPSMETERDEBUG = false;
		DPSMeter:Print("Debug: false");
		else
		DPSMETERDEBUG = true;
		DPSMeter:Print("Debug: true");
		end
	end
end

local s2 = sqrt(2);
local cos, sin, rad = math.cos, math.sin, math.rad;
local function CalculateCorner(angle)
	local r = rad(angle);
	return 0.5 + cos(r) / s2, 0.5 + sin(r) / s2;
end

function DPSRotateTexture(texture,amount)
	local tempmax = DPSM_MAXCHART;
	if (-amount > tempmax) then -- uu we have new session record
	local newmax = math.ceil( (-amount) / 40 )*40;
	DPSM_MAXCHART = newmax;
	local tick = newmax/8;
	for i=1,7 do
		getglobal("DPSmarker"..i):SetText(tick*i);
	end
	tempmax = newmax;
	end
	local fixedrot = -(( (-amount)/tempmax )*275);
	DPSRotTexture(texture, fixedrot);
end 

function DPSRotTexture(texture, angle)
	local LRx, LRy = CalculateCorner(angle + 45);
	local LLx, LLy = CalculateCorner(angle + 135);
	local ULx, ULy = CalculateCorner(angle + 225);
	local URx, URy = CalculateCorner(angle - 45);	
	texture:SetTexCoord(ULx, ULy, LLx, LLy, URx, URy, LRx, LRy);
end

function Speedostick_Update()
	DPSMeter_CheckTimer();
	if (DPSM_COMBAT == true) then
		DPSMeterFrame:SetAlpha(DPSMeter.db.char.alpha2);
		local now = GetTime();
		local diff = (now-DPSM_TIME);
		local dpswas = (DPSM_DAMAGE/diff);
		local rounded = DPSMeter_round(dpswas);
		if (diff > 0.9) then
		DPSRotateTexture(Speedostick, -dpswas);
		end
		if (rounded > DPSSESSIONBEST) then
		DPSSESSIONBEST = rounded;
		end
		DPSDigital:SetText(""..rounded);
	else
	DPSMeterFrame:SetAlpha(DPSMeter.db.char.alpha);
	end
end

function DPSmeter_MouseUp(self, button)
	if ( self.isMoving ) then
  	self:StopMovingOrSizing();
  	self.isMoving = false;
 	end
end

function DPSmeter_MouseDown(self, button)
	if ( button == "RightButton") then
	DPSMeter_Menu();
	end
	if ( ( ( not self.isLocked ) or ( self.isLocked == 0 ) ) and ( button == "LeftButton" ) ) then
 	self:StartMoving();
 	self.isMoving = true;
 	end
end

function DPSMeter:CHAT_MSG_ADDON()
	--DPSMeter:Print("call: "..arg1..", "..arg2..", "..arg3);
	if (arg4 == UnitName("player")) then return end
	if (arg1 == "DPSMETERVERSION") then	
	 	if (tonumber(arg2) > DPSMETERVERSION) then
	 		DPSMeter:Print("An updated DPSMeter detected! (version "..arg2..", from "..arg4..")");
	 	end
	end
end


function DPSMeter:OnInitialize()
    --No need for this
end

function DPSMeter:OnEnable()
	DPSMeter:RegisterDB("DPSMeterDB","DPSMeterDBPC");
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	self:RegisterEvent("PLAYER_REGEN_ENABLED");
	self:RegisterEvent("PLAYER_DEAD");
	self:RegisterEvent("CHAT_MSG_ADDON");
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED",DPSMeter_parse);
	self:RegisterEvent("PARTY_MEMBERS_CHANGED",DPSMeter_updateparty);
	SLASH_DPS1 = "/DPS";
	SlashCmdList["DPS"] = DPSMeter_ParseC;
	DPSMETERNAMES[UnitGUID("player")] = UnitName("player");
	DPSMeter_updateparty();
    if (DPSMeter.db.char.frame == nil) then
    DPSMeter.db.char.frame = "1";
    end
    if (DPSMeter.db.char.damage == nil) then
    DPSMeter.db.char.damage = 0;
    end
    if (DPSMeter.db.char.lock == nil) then
    DPSMeter.db.char.lock = false;
    end
    if (DPSMeter.db.char.scale == nil) then
    DPSMeter.db.char.scale = 1;
    end
    if (DPSMeter.db.char.scen == nil) then
    DPSMeter.db.char.scen = false;
    end
    if (DPSMeter.db.char.heal == nil) then
    DPSMeter.db.char.heal = false;
    end
    if (DPSMeter.db.char.record == nil) then
    DPSMeter.db.char.record = false;
    end
    if (DPSMeter.db.char.alpha == nil) then
    DPSMeter.db.char.alpha = 0.8;
    end
    if (DPSMeter.db.char.alpha2 == nil) then
    DPSMeter.db.char.alpha2 = 1;
    end
	if (DPSMeter.db.char.skin == nil) then
    DPSMeter.db.char.skin = true;
    end
	if (DPSMeter.db.char.record == false) then
		DPSMeterDamage:Hide();
	end
    DPSMeterFrame:SetAlpha(DPSMeter.db.char.alpha);
    DPSMeterFrame:SetScale(DPSMeter.db.char.scale);
	DPSMeterFrame.isLocked = DPSMeter.db.char.lock;
	DPSMeterDamage.isLocked = DPSMeter.db.char.lock;
	if (DPSMeter.db.char.lock == true) then
		DPSDamageResize:Hide();
	end
	if (DPSMeter.db.char.skin == false) then
		DPSMeter_DigitSkin();
	end
    -- Loaded
    DEFAULT_CHAT_FRAME:AddMessage("|cff33ff33DPS Meter|r |cff77cc77 v"..DPSMETERVERSION.." loaded.|r");
end

function DPSMeter:OnDisable()
    -- Nothing here yet (WIP) :D
end


-- #############DAMAGEMETER BARWINDOW FUNCS ##############
function GetDpsBarNum()
	local isRaid, isParty, members;
	local raid = GetNumRaidMembers();
	if (raid == 0) then isRaid = false; else isRaid = true; end
	if (isRaid == false) then
	members = 1+GetNumPartyMembers(); --parteeeiiiii
	else
	members = raid; -- raid
	end
	return members;
end

function SetBarValues(what)
		local sorta = {};
		local data = {};
		local orig = {};
		local name = UnitName("player");
		local dmg = DPSDMGMETERS[what][name];
		if (dmg == nil) then dmg = 0; end
		if (DPSDMGMETERINFO["isRaid"] == false) then 
			--DPSMeter_swpr(name..": "..dmg.." "..what, where); OLD
			local x = DPSDMGMETERINFO["members"];
			data[x+1] = name;
			sorta[x+1] = dmg;
			orig[x+1] = dmg;
		end
		--now start others
		if (DPSDMGMETERINFO["isRaid"] == true) then
		--woo raid
			for i=1, DPSDMGMETERINFO["members"], 1 do
				local uid = "raid"..i;
				local name = UnitName(uid);
				local dmg = DPSDMGMETERS[what][name];
				if (dmg == nil) then dmg = 0; end
				--DPSMeter_swpr(name..": "..dmg.." "..what, where); OLD
				data[i] = name;
				sorta[i] = dmg;
				orig[i] = dmg;
			end 
		else if (DPSDMGMETERINFO["isParty"] == true) then
		--woo party
			for i=1, DPSDMGMETERINFO["members"], 1 do
				local uid = "party"..i;
				local name = UnitName(uid);
				local dmg = DPSDMGMETERS[what][name];
				if (dmg == nil) then dmg = 0; end
				--DPSMeter_swpr(name..": "..dmg.." "..what, where); OLD
				data[i] = name;
				sorta[i] = dmg;
				orig[i] = dmg;
			end 
		end	
		end
		--DPSMeter_PrintLines(data, orig, sorta, what, where);
		--DPSMeter_PrintLines(names, orig, sorti, what, where)
		local maxdmg, cur, perse;
		table.sort(sorta, function(a,b) return a>b end)
		for i,n in pairs(sorta) do
			local t = DPSMeter_findkey(orig,n);
			local w = data[t];
			--DPSMeter_swpr(i..". "..w..": "..n.." "..what, where);
			if (i == 1) then maxdmg = n; end;
			totaldmg = DPSDMGTOTALS[what];
			if ((n == 0) or (maxdmg == 0) or (maxdmg == nil)) then
			cur = 0;
			else
			cur = (n/maxdmg)*100;
			end
			if (totaldmg > 0) then
			perse = floor((n/totaldmg)*1000)/10;
			else
			perse = 0;
			end
			getglobal("DPSDamageBar"..i):SetValue(cur);
			getglobal("DPSDamageBarName"..i):SetText(i..". "..w);
			if (w == UnitName("player")) then
			getglobal("DPSDamageBar"..i):SetStatusBarColor(1,0,0,1);
			else
			getglobal("DPSDamageBar"..i):SetStatusBarColor(0.6,0.4,1,1);
			end
			getglobal("DPSDamageBarText"..i):SetText(n.." ("..perse.." %)");
			orig[t] = nil;
		end
end

function DPSMeterDamage_Next()
	--switch button
	if (DPSSHOWING == "damage") then
	DPSSHOWING = "healing";
	DPSTitle:SetText("Healing done");
	else
	DPSSHOWING = "damage";
	DPSTitle:SetText("Damage done");
	end
end

function DPSMeterDamage_Hide()
	--close
	DPSMeter.db.char.record = false;
	DPSMeterDamage:Hide();
end

function DPSMeterDamage_BC()
	--broadcast
	dewdrop:Open(DPSDamageBC,
    'children', 
    function()
        dewdrop:AddLine('text', "Print to chat frame", 'func', DPSMeter_PrintRec, 'arg1', DPSSHOWING, 'tooltipTitle', "Print DMG Meters",	'tooltipText', "Print all damage meter records to chat frame")
        dewdrop:AddLine('text', "Broadcast to party/raid", 'func', DPSMeter_PrintRec, 'arg1', DPSSHOWING, 'arg2', 'SAY', 'tooltipTitle', "Broadcast DMG Meters",	'tooltipText', "Broadcast all damage meter records to party/raid chat")
	end)
end

function DPSMeter_DamageStart()
	DPSMETERBARS = 0;
	DPSSHOWING = "damage";
	DPSMeter_SetBars(GetDpsBarNum());
end

function DPSMeter_SetBars(num)
	--setup enough bars
	if (num > DPSMETERBARS) then
		for i=DPSMETERBARS+1, num do
			local bar = CreateFrame("StatusBar","DPSDamageBar"..i, DPSMeterDamage);
			bar:SetPoint("TOPLEFT",DPSMeterDamage,"TOPLEFT", 4, -((i-1)*13)-4);
			bar:SetWidth(142);
			bar:SetHeight(12);
			bar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar", "BACKGROUND");
			bar:SetStatusBarColor(1,1,1,1);
			bar:SetMinMaxValues(0,100);
			bar:SetValue(100);
			local text = bar:CreateFontString("DPSDamageBarName"..i, "OVERLAY");
			text:SetFontObject("GameFontHighlightSmall")
			text:SetText("Error")
			text:SetPoint("TOPLEFT",DPSMeterDamage,"TOPLEFT", 6, -((i-1)*13)-5);
			local text = bar:CreateFontString("DPSDamageBarText"..i, "OVERLAY");
			text:SetFontObject("GameFontHighlightSmall")
			text:SetText("0")
			text:SetPoint("TOPRIGHT",DPSMeterDamage,"TOPRIGHT", -4, -((i-1)*13)-5);
		end
		DPSMETERBARS = num;
	end
end

function DPSMeter_BarsUpdate(self)
	--update the bars
	DPSMeterDamageTop:SetWidth(DPSMeterDamage:GetWidth());
	local he = DPSMeterDamage:GetHeight()-6;
	local members = GetDpsBarNum();
	local bar;
	for i=1, DPSMETERBARS, 1 do
		bar = getglobal("DPSDamageBar"..i);
		if ((i > members) or (he <= (i*13))) then
			--hide bar
			bar:Hide();
		else
			if (bar:IsShown() == nil) then bar:Show(); end
			bar:SetWidth(DPSMeterDamage:GetWidth()-8);
		end
	end
	SetBarValues(DPSSHOWING);
end
